/* 30 June 2012

   Written by Ruud Harmsen, in order to
   obtain some data for the article
   https://rudhar.com/economi/monydebt/en/002multi.htm

   Feel free to use this as a basis for your own
   calculations, if you feel like it.
 */

#include <stdio.h>
#define RESERVE    10.0
#define ORIG      100.0
#define KEEPCASH    5.0

static void PrintBalanceSheet (void);

static double CashInBank  = ORIG;
static double Loans       = 0.0;
static double DemandDepos = ORIG;
static double CashInPubl  = 0.0;

int main (void)
{
   double ExcessReserve;
   double ThisLoan, Returns;
   int i;
      
   for (i = 0; i < 1000; i++)
   {
      ExcessReserve = CashInBank - (DemandDepos * (RESERVE / 100.0));
      ThisLoan = ExcessReserve;

      printf("New Loan  = %7.2f\n\n", ThisLoan);

      /* Loan Booking */
      CashInBank -= ThisLoan;
      Loans      += ThisLoan;
      CashInPubl += ThisLoan;
      PrintBalanceSheet();
      
      /* Part of the cash returns */
      Returns = ThisLoan * ((100 - KEEPCASH) / 100.0);
      printf("Returning = %7.2f\n\n", Returns);

      CashInBank  += Returns;
      DemandDepos += Returns;
      CashInPubl  -= Returns;
      PrintBalanceSheet();
   }
   return 0;
}

static void PrintBalanceSheet (void)
{
   printf("==\n");
   printf("Cash in bank\t%7.2f\n", CashInBank);   
   printf("Check.Accts.\t\t%7.2f\n", DemandDepos);   
   printf("Loans       \t%7.2f\n", Loans);   
   printf("\nCash in Public: %7.2f\n", CashInPubl);
   printf("==\n\n");
}

